<script setup lang="ts">
import { useAuthStore } from '@/stores/auth'
import { useBranchStore } from '@/stores/branch'
import { useExpenseStore } from '@/stores/expense'
import type { Branch } from '@/types/Branch'
import type { Expense } from '@/types/Expense'
import type { User } from '@/types/User'
import { computed, nextTick, ref, onMounted } from 'vue'
import type { VForm } from 'vuetify/components'

const expensesStore = useExpenseStore()
const branchStore = useBranchStore()

const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Branch',
    key: 'branchName',
    // value: 'branchName'
    value: (items: any | Branch) => items.branchName.address
  },

  {
    title: 'Bill Type',
    key: 'billType',
    value: 'billType'
  },
  {
    title: 'Total Amount',
    key: 'totalAmount',
    value: 'totalAmount'
  },
  {
    title: 'Date',
    key: 'createDate',
    value: (expense: any) => new Date(expense.createDate).toLocaleDateString('en-GB')
  },

  { title: 'Actions', key: 'actions', sortable: false }
]

const page = ref(1)

const itemsPerPage = ref<any>(10)
const tab = ref(null)
const pageCount = computed(() => {
  return Math.ceil(expensesStore.expenses.length / itemsPerPage.value)
})
const refForm = ref<VForm | null>(null)

const dialog = ref(false)
const dialogSelectBranch = ref(false)
const loading = ref(false)
const form = ref(false)
const dialogDelete = ref(false)
const dialogView = ref(false)
const dialogWater = ref(false)
const dialogElec = ref(false)
const dialogOthers = ref(false)
const dialogMonthly = ref(false)

const selectedBranchIndex = ref(null)
const userStore = useAuthStore()

function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    expensesStore.clearForm()
  })
}

async function deleteItemConfirm() {
  // Delete item from list
  await expensesStore.deleteExpense()
  closeDelete()
}

async function deleteItem(item: Expense) {
  if (!item.id) return
  await expensesStore.getExpense(item.id)
  dialogDelete.value = true
}

function closeDialog() {
  dialog.value = false
  nextTick(() => {
    expensesStore.clearForm()
  })
  dialogSelectBranch.value = false
  dialogMonthly.value = false
  dialogWater.value = false
  dialogView.value = false
  dialogElec.value = false
  dialogOthers.value = false
}

async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  closeDialog()
  await expensesStore.saveExpense()
}

function showExpense(item: Expense) {
  selectedExpense = item
  dialogView.value = true
}
function closeExpenseDetail() {
  dialogView.value = false
}

function showMonthExp() {
  expensesStore.monthExpense(expensesStore.editedExpense)
  closeDialog()
}

const showTableBranch = (branch: any) => {
  if (branch) {
    selectedBranchIndex.value = branch.id
  }
  dialogSelectBranch.value = false
  dialogDelete.value = false
  console.log('Selected branch:', branch)
}

let selectedExpense: Expense | null = null

onMounted(async () => {
  await expensesStore.getExpenses()
  await branchStore.getBranchs()
  expensesStore.editedExpense.createDate = new Date()
  // expensesStore.monthExpense(expensesStore.editedExpense)
})

const search = ref<string>('')

const formattedExpenses = computed(() =>
  expensesStore.expenses.map((expense) => ({
    ...expense
  }))
)

const filteredUsers = computed(() => {
  // const searchLower = search.value.toLowerCase()
  // if (selectedBranchIndex.value !== null) {
  //   // Filter expenses based on the selected branch
  //   return formattedExpenses.value.filter(
  //     (expense) =>
  //       expense.name.toLowerCase().includes(searchLower) &&
  //       expense.branchName && // Make sure branchName is not null or undefined
  //       expense.branchName.id === selectedBranchIndex.value // Assuming branchName contains an object with an id property
  //   )
  // } else {
  //   // Return all expenses if no branch is selected
  //   return formattedExpenses.value.filter((expense) =>
  //     expense.name.toLowerCase().includes(searchLower)
  //   )
  // }
  const searchLower = search.value.toLowerCase()

  if (isBranch.value != 1 && isOwner.value !== true) {
    // Filter expenses based on the branchId of the logged-in user
    return formattedExpenses.value.filter(
      (expense) =>
        expense.name.toLowerCase().includes(searchLower) &&
        expense.branchName && // Make sure branchName is not null or undefined
        expense.branchName.id === isBranch.value // Assuming branchName contains an object with an id property
    )
  } else {
    // Return all expenses if the user is not associated with any branch
    return formattedExpenses.value.filter((expense) =>
      expense.name.toLowerCase().includes(searchLower)
    )
  }
})

// const filteredEX = computed(() => {
//   const searchLower = search.value.toLowerCase()
//   if (selectedBranchIndex.value !== null) {
//     // Filter expenses based on the selected branch
//     return formattedExpenses.value.filter(
//       (expense) =>
//         expense.name.toLowerCase().includes(searchLower) &&
//         expense.branchName && // Make sure branchName is not null or undefined
//         expense.branchName.id === selectedBranchIndex.value // Assuming branchName contains an object with an id property
//     )
//   } else {
//     // Return all expenses if no branch is selected
//     return formattedExpenses.value.filter((expense) =>
//       expense.name.toLowerCase().includes(searchLower)
//     )
//   }
// })
const isAdmin = computed(() => {
  const currentUser: User | null = userStore.getCurrentUser()
  if (currentUser !== null && currentUser !== undefined) {
    return currentUser.roles.some((role) => role.name === 'Manager' || role.name === 'Owner')
  }
  return false
})

const isOwner = computed(() => {
  const currentUser: User | null = userStore.getCurrentUser()
  if (currentUser !== null && currentUser !== undefined) {
    return currentUser.roles.some((role) => role.name === 'Owner')
  }
  return false
})

const isBranch = computed(() => {
  const currentUser: User | null = userStore.getCurrentUser()
  if (currentUser !== null && currentUser !== undefined) {
    return currentUser.branch.id
  }
  return false
})
</script>

<template>
  <div>
    <v-card-title class="d-flex align-center pe-2">
      <v-icon size="50">mdi-invoice-list-outline</v-icon>
      <h1 style="text-align: left" class="ml-5">EXPENSES</h1>
    </v-card-title>
    <!-- ช่องค้นหา -->
    <v-row
      ><v-col cols="12" sm="6"
        ><v-text-field
          class="ma-2"
          v-model="search"
          max-width="200px"
          prepend-inner-icon="mdi-magnify"
          density="compact"
          label="Search"
          single-line
          flat
          hide-details
          variant="solo-filled"
        ></v-text-field
      ></v-col>
      <v-col>
        <!-- dialog เพิ่มค่าใช้จ่าย -->
        <v-dialog v-model="dialog" persistent width="700">
          <template v-slot:activator="{ props }">
            <v-btn class="ma-2" style="text-align: left" color="success" v-bind="props">
              <v-icon icon=" mdi-playlist-edit" size="25px" class="mr-2" color="#FFFFFF"></v-icon>
              <div style="text-align: center; color: aliceblue">Add Expense</div>
            </v-btn>
          </template>
          <v-card title="Expense" class="pt-6" style="text-align: center"
            ><v-card-text>
              <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                <v-container>
                  <v-row>
                    <v-col cols="12" sm="6">
                      <v-text-field
                        v-model="expensesStore.editedExpense.name"
                        :readonly="loading"
                        :rules="[(v) => !!v || 'required']"
                        class="mb-2"
                        clearable
                        label=" Username"
                        variant="outlined"
                      ></v-text-field>
                    </v-col>

                    <v-col cols="12" sm="6">
                      <v-combobox
                        v-model="expensesStore.editedExpense.branchName"
                        :items="branchStore.branchs"
                        :readonly="loading"
                        :rules="[(v) => !!v || 'required']"
                        item-title="address"
                        item-value="id"
                        class="mb-2"
                        label="Select Branch"
                        variant="outlined"
                        :return-object="true"
                      ></v-combobox>
                    </v-col>

                    <v-col cols="12" sm="6">
                      <v-combobox
                        v-model="expensesStore.editedExpense.billType"
                        :rules="[(v) => !!v || 'required']"
                        class="mb-2"
                        :items="['Water', 'Electricity', 'Others']"
                        label="Select Type"
                        variant="outlined"
                        :return-object="true"
                      ></v-combobox>
                    </v-col>

                    <v-col cols="12" sm="6">
                      <v-text-field
                        v-model="expensesStore.editedExpense.totalAmount"
                        :rules="[(v) => !!v || 'required']"
                        :readonly="loading"
                        class="mb-2"
                        clearable
                        label="Total Amount"
                        variant="outlined"
                      ></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="6">
                      <v-text-field
                        v-model="expensesStore.editedExpense.createDate"
                        :readonly="loading"
                        :rules="[(v) => !!v || 'required']"
                        class="mb-2"
                        label="Open Date"
                        variant="outlined"
                        type="Date"
                      ></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="6">
                      <v-text-field
                        v-if="expensesStore.editedExpense.billType === 'Others'"
                        :rules="[(v) => !!v || 'required']"
                        v-model="expensesStore.editedExpense.note"
                        :readonly="loading"
                        class="mb-2"
                        label="Note"
                        variant="outlined"
                      ></v-text-field>
                    </v-col>
                  </v-row>
                </v-container>
              </v-form>
              <small class="div">*indicates required field</small> </v-card-text
            ><v-card-actions>
              <v-spacer></v-spacer>
              <v-btn
                color="red"
                style="width: 150px; height: 50px"
                variant="flat"
                @click="closeDialog()"
                class="ms-2"
                >Cancel</v-btn
              >

              <v-btn
                style="width: 150px; height: 50px"
                variant="flat"
                @click="save()"
                class="ms-3"
                color="success"
                >Save</v-btn
              >
            </v-card-actions></v-card
          > </v-dialog
        ><v-menu id="menu-activator" v-if="isOwner">
          <template v-slot:activator="{ props }">
            <v-btn class="ma-2" color="rgb(139, 82, 38)" v-bind="props"> Select Branch </v-btn>
          </template>
          <v-list>
            <v-list-item
              v-for="(branch, index) in branchStore.branchs"
              :key="index"
              @click="showTableBranch(branch)"
            >
              <v-list-item-title style="text-align: center">{{ branch.address }}</v-list-item-title>
            </v-list-item>
          </v-list>
        </v-menu>
      </v-col>
    </v-row>
  </div>

  <!-- dialog ลบ -->
  <v-dialog v-model="dialogDelete" max-width="500px">
    <v-card>
      <v-card-title class="font ma-4 pt-6" style="text-align: center"
        >you want to delete this info? 🗑️</v-card-title
      >
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn
          color="red"
          variant="flat"
          style="width: 150px; height: 50px"
          class="mb-3"
          @click="closeDelete"
          >Cancel</v-btn
        >
        <v-btn
          color="success"
          variant="flat"
          style="width: 150px; height: 50px"
          class="mb-3"
          @click="deleteItemConfirm"
          >OK</v-btn
        >
        <v-spacer></v-spacer>
      </v-card-actions>
    </v-card>
  </v-dialog>

  <!-- dialog Expense detail -->
  <v-dialog v-model="dialogView" persistent width="400">
    <v-card>
      <v-card-title class="font ma-4 pt-6" style="text-align: center"
        >Expense Details
      </v-card-title>
      <v-card-text>
        <div v-if="selectedExpense" style="text-align: start">
          <p>Date : {{ new Date(selectedExpense.createDate).toLocaleDateString('en-GB') }}</p>
          <p>Name : {{ selectedExpense.name }}</p>
          <p>Branch : {{ selectedExpense.branchName?.address }}</p>
          <p>Bill Type : {{ selectedExpense.billType }}</p>
          <p>Note : {{ selectedExpense.note }}</p>
          <p>Total Amount : {{ selectedExpense.totalAmount }}</p>
        </div>
      </v-card-text>
      <v-card-actions
        ><v-spacer></v-spacer>
        <v-btn color="red" variant="flat" class="mb-3" @click="closeExpenseDetail()">Close</v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>

  <v-tabs v-model="tab" align-tabs="center" color="brown">
    <v-tab :to="{ name: 'expense' }">Expense</v-tab>
    <v-tab :to="{ name: 'monthly-expense' }" v-if="isAdmin">Monthly Expenses</v-tab>
    <v-tab :to="{ name: 'annual-expense' }" v-if="isAdmin">Annual Expenses</v-tab>
  </v-tabs>

  <v-card-title>
    <div>
      <v-data-table
        v-model:page="page"
        :headers="headers"
        :items="filteredUsers"
        :items-per-page="itemsPerPage"
        ><template v-slot:bottom>
          <div class="text-center pt-2">
            <v-pagination v-model="page" :length="pageCount"></v-pagination>
          </div> </template
        ><template v-slot:[`item.actions`]="{ item }">
          <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
          <v-icon size="small" @click="showExpense(item)"> mdi-eye </v-icon>
        </template>
      </v-data-table>
    </div>
  </v-card-title>
</template>
<style>
div {
  font-family: 'Kanit';
}
</style>
